local BarHeight=18
local BarWidth=200
local TotalBuffs=5
local PlayersShown=8
local RowsCreated=8
local BuffSpacing=18

local BuffWindow_Functions={}

local BuffWindow_ResizeWindow, BuffWindow_UpdateWindow, BuffWindow_UpdateBuffs

local RL = AceLibrary("Roster-2.1")
local aura = AceLibrary("SpecialEvents-Aura-2.0")
local L = AceLibrary("AceLocale-2.2"):new("BigBrother")
local BS = LibStub("LibBabble-Spell-3.0"):GetLookupTable()

local BigBrother_Flasks={
{L["Mr Pinchy's Blessing"],"INV_Misc_Fish_14.blp"},
{L["Flask of Fortification"],"Interface\\Icons\\INV_Potion_119.blp"},
{L["Flask of the Titans"],"Interface\\Icons\\INV_Potion_62.blp"},
{L["Flask of Mighty Restoration"],"Interface\\Icons\\INV_Potion_118.blp"},
{L["Supreme Power"],"Interface\\Icons\\INV_Potion_41.blp",L["Flask of Supreme Power"]},
{L["Flask of Relentless Assault"],"Interface\\Icons\\INV_Potion_117.blp"},
{L["Mighty Restoration of Shattrath"],"Interface\\Icons\\INV_Potion_118.blp",L["Shattrath Flask of Mighty Restoration"]},
{L["Fortification of Shattrath"],"Interface\\Icons\\INV_Potion_119.blp",L["Shattrath Flask of Fortification"]},
{L["Relentless Assault of Shattrath"],"Interface\\Icons\\INV_Potion_117.blp",L["Shattrath Flask of Relentless Assault"]},
{L["Supreme Power of Shattrath"],"Interface\\Icons\\INV_Potion_41.blp",L["Shattrath Flask of Supreme Power"]},
{L["Unstable Flask of the Bandit"],"Interface\\Icons\\INV_Potion_91.blp"},
{L["Unstable Flask of the Beast"],"Interface\\Icons\\INV_Potion_35.blp"},
{L["Unstable Flask of the Elder"],"Interface\\Icons\\INV_Potion_77.blp"},
{L["Unstable Flask of the Physician"],"Interface\\Icons\\INV_Potion_70.blp"},
{L["Unstable Flask of the Soldier"],"Interface\\Icons\\INV_Potion_84.blp"},
{L["Unstable Flask of the Sorcerer"],"Interface\\Icons\\INV_Potion_42.blp"},
{L["Flask of Pure Death"],"Interface\\Icons\\INV_Potion_115.blp"},
{L["Flask of Blinding Light"],"Interface\\Icons\\INV_Potion_116.blp"},
{L["Chromatic Wonder"],"Interface\\Icons\\INV_Potion_48.blp"},
{L["Chromatic Resistance"],"Interface\\Icons\\INV_Potion_48.blp"},
{L["Distilled Wisdom"],"Interface\\Icons\\INV_Potion_97.blp"},
}
local BigBrother_Elixirs_Battle={
{L["Fel Strength Elixir"],"Interface\\Icons\\INV_Potion_149.blp"},
{L["Onslaught Elixir"],"Interface\\Icons\\INV_Potion_58.blp"},
{L["Major Strength"],"Interface\\Icons\\INV_Potion_147.blp",L["Elixir of Major Strength"]},
{L["Major Agility"],"Interface\\Icons\\INV_Potion_127.blp",L["Elixir of Major Agility"]},
{L["Elixir of Mastery"],"Interface\\Icons\\INV_Potion_111.blp"},
{L["Major Firepower"],"Interface\\Icons\\INV_Potion_146.blp",L["Elixir of Major Firepower"]},
{L["Major Shadow Power"],"Interface\\Icons\\INV_Potion_145.blp",L["Elixir of Major Shadow Power"]},
{L["Major Frost Power"],"Interface\\Icons\\INV_Potion_148.blp",L["Elixir of Major Frost Power"]},
{L["Adept's Elixir"],"Interface\\Icons\\INV_Potion_96.blp"},
{L["Arcane Elixir"],"Interface\\Icons\\INV_Potion_30.blp"},
{L["Greater Arcane Elixir"],"Interface\\Icons\\INV_Potion_25.blp"},
{L["Healing Power"],"Interface\\Icons\\INV_Potion_142.blp",L["Elixir of Healing Power"]},
{L["Elixir of the Mongoose"],"Interface\\Icons\\INV_Potion_32.blp"},
}
local BigBrother_Elixirs_Guardian={
{L["Major Armor"],"Interface\\Icons\\INV_Potion_122.blp",L["Elixir of Major Defense"]},
{L["Greater Armor"],"Interface\\Icons\\INV_Potion_66.blp",L["Elixir of Superior Defense"]},
{L["Greater Mana Regeneration"],"Interface\\Icons\\INV_Potion_151.blp",L["Elixir of Major Mageblood"]},
{L["Mana Regeneration"],"Interface\\Icons\\INV_Potion_45.blp",L["Mageblood Potion"]},
{L["Earthen Elixir"],"Interface\\Icons\\INV_Potion_154.blp"},
{L["Elixir of Draenic Wisdom"],"Interface\\Icons\\INV_Potion_155.blp"},
{L["Elixir of Major Fortitude"],"Interface\\Icons\\INV_Potion_158.blp"},
{L["Greater Intellect"],"Interface\\Icons\\INV_Potion_10.blp"},
{L["Empowerment"],"Interface\\Icons\\INV_Potion_136.blp",L["Elixir of Empowerment"]},
{L["Elixir of Ironskin"],"Interface\\Icons\\INV_Potion_159.blp"},
}
local BigBrother_Foodbuffs={
{L["Well Fed"],"Interface\\Icons\\Spell_Misc_Food.blp"},
{L["\"Well Fed\""],"Interface\\Icons\\INV_Drink_23.blp"},
{L["Enlightened"],"Interface\\Icons\\Spell_Misc_Food.blp"},
{L["Electrified"],"Interface\\Icons\\Spell_Lightning_LightningBolt01.blp"},
}

local function Sort_RaidBuffs(a,b)
	if a.totalBuffs<b.totalBuffs then
		return true
	elseif a.totalBuffs>b.totalBuffs then
		return false
	elseif a.name<b.name then
		return true
	end
	return false
end

local function Sort_PallyBuffs(a,b)
	if a.class<b.class then
		return true
	elseif a.class>b.class then
		return false
	elseif a.name<b.name then
		return true
	end
	return false
end

local BigBrother_BuffTable={
	{
		name=L["Raid Buffs"],
		sortFunc=Sort_RaidBuffs,
		buffs={
			{{BS["Arcane Intellect"],"Interface\\Icons\\Spell_Holy_MagicalSentry.blp"},{BS["Arcane Brilliance"],"Interface\\Icons\\Spell_Holy_ArcaneIntellect.blp"}},
			{{BS["Power Word: Fortitude"],"Interface\\Icons\\Spell_Holy_WordFortitude.blp"},{BS["Prayer of Fortitude"],"Interface\\Icons\\Spell_Holy_PrayerOfFortitude.blp"}},
			{{BS["Mark of the Wild"],"Interface\\Icons\\Spell_Nature_Regeneration.blp"},{BS["Gift of the Wild"],"Interface\\Icons\\Spell_Nature_GiftoftheWild.blp"}},
			{{BS["Shadow Protection"],"Interface\\Icons\\Spell_Shadow_AntiShadow.blp"},{BS["Prayer of Shadow Protection"],"Interface\\Icons\\Spell_Holy_PrayerofShadowProtection.blp"}},
			{{BS["Divine Spirit"],"Interface\\Icons\\Spell_Holy_DivineSpirit"},{BS["Prayer of Spirit"],"Interface\\Icons\\Spell_Holy_PrayerofSpirit.blp"}}
		}
	},
	{
		name=L["Paladin Buffs"],
		sortFunc=Sort_PallyBuffs,
		buffs={
			{{BS["Blessing of Kings"],"Interface\\Icons\\Spell_Magic_MageArmor.blp"},{BS["Greater Blessing of Kings"],"Interface\\Icons\\Spell_Magic_GreaterBlessingofKings.blp"}},
			{{BS["Blessing of Light"],"Interface\\Icons\\Spell_Holy_PrayerOfHealing02.blp"},{BS["Greater Blessing of Light"],"Interface\\Icons\\Spell_Holy_GreaterBlessingofLight.blp"}},
			{{BS["Blessing of Might"],"Interface\\Icons\\Spell_Holy_FistOfJustice.blp"},{BS["Greater Blessing of Might"],"Interface\\Icons\\Spell_Holy_GreaterBlessingofKings.blp"}},
			{{BS["Blessing of Salvation"],"Interface\\Icons\\Spell_Holy_SealOfSalvation.blp"},{BS["Greater Blessing of Salvation"],"Interface\\Icons\\Spell_Holy_GreaterBlessingofSalvation.blp"}},
			{{BS["Blessing of Wisdom"],"Interface\\Icons\\Spell_Holy_SealOfWisdom.blp"},{BS["Greater Blessing of Wisdom"],"Interface\\Icons\\Spell_Holy_GreaterBlessingofWisdom.blp"}}
		}
	},
	{
		name=L["Consumables"],
		sortFunc=Sort_PallyBuffs,
		buffs={
			{},
			BigBrother_Flasks,
			BigBrother_Elixirs_Battle,
			BigBrother_Elixirs_Guardian,
      BigBrother_Foodbuffs,
		}
	}
}

function BuffWindow_Functions:CreateBuffRow(parent, xoffset, yoffset)
	local Row=CreateFrame("FRAME",nil,parent)

	Row:SetPoint("TOPLEFT",parent,"TOPLEFT",xoffset,yoffset)
	Row:SetHeight(BarHeight)
	Row:SetWidth(BarWidth)
	Row:Show()
	
	Row.Background=Row:CreateTexture(nil,"BACKGROUND")
	Row.Background:SetAllPoints(Row)
	Row.Background:SetTexture("Interface\\Buttons\\WHITE8X8.blp")
	Row.Background:SetGradientAlpha("HORIZONTAL",1.0/2,0.0,0.0,0.8,1.0/2,0.0,0.0,0.0)
	Row.Background:Show()

	Row.Name=Row:CreateFontString(nil,"OVERLAY","GameFontNormal")	
	Row.Name:SetPoint("LEFT",Row,"LEFT",4,0)
	Row.Name:SetTextColor(1.0,1.0,1.0)
	Row.Name:SetText("Test")

	

	Row.Buff={}
	for i=1,TotalBuffs do
		Row.Buff[i]=CreateFrame("FRAME",nil,Row)		
		Row.Buff[i]:SetPoint("RIGHT",Row,"RIGHT",-4-(TotalBuffs-i)*BuffSpacing,0)
		Row.Buff[i]:SetHeight(16)
		Row.Buff[i]:SetWidth(16)

		Row.Buff[i].texture=Row.Buff[i]:CreateTexture(nil,"OVERLAY")
		Row.Buff[i].texture:SetAllPoints(Row.Buff[i])
		Row.Buff[i].texture:SetTexture("Interface\\Buttons\\UI-CheckBox-Check.blp")
			
		Row.Buff[i].BuffIndex=0
		--GameTooltip:ClearLines();GameTooltip:AddLine(this.BuffName);GameTooltip:Show()
		Row.Buff[i]:SetScript("OnEnter", BuffWindow_Functions.OnEnterBuff)
		Row.Buff[i]:SetScript("OnLeave", BuffWindow_Functions.OnLeaveBuff)
		Row.Buff[i]:EnableMouse()

		Row.Buff[i]:Show()
	end

	Row.SetPlayer=BuffWindow_Functions.SetPlayer
	Row.SetBuffValue=BuffWindow_Functions.SetBuffValue
	Row.SetBuffIcon=BuffWindow_Functions.SetBuffIcon
	Row.SetBuffIndex=BuffWindow_Functions.SetBuffIndex

	return Row
end

function BuffWindow_Functions:OnEnterBuff()
	GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT")
	GameTooltip:SetUnitBuff(self.unit, self.BuffIndex)
	GameTooltip:Show()
end

function BuffWindow_Functions:OnLeaveBuff()
	GameTooltip:Hide()
end


function BuffWindow_Functions:SetPlayer(player,class,unit)
	self.Name:SetText(player)
	local color=RAID_CLASS_COLORS[class]
	self.Background:SetGradientAlpha("HORIZONTAL",color.r/1.5,color.g/1.5,color.b/1.5,0.8,color.r/1.5,color.g/2,color.b/1.5,0)
end

function BuffWindow_Functions:SetBuffValue(num,enabled)
	if enabled then
		self.Buff[num]:Show()
	else
		self.Buff[num]:Hide()
	end
end

function BuffWindow_Functions:SetBuffIcon(num,texture)
	self.Buff[num].texture:SetTexture(texture)
end

function BuffWindow_Functions:SetBuffIndex(num,index,unit)
	self.Buff[num].BuffIndex=index
	self.Buff[num].unit=unit
end

function ToggleBuffWindow()
	if BigBrother_BuffWindow then
		if BigBrother_BuffWindow:IsShown() then
			BigBrother_BuffWindow:Hide()
		else
			BuffWindow_UpdateBuffs()
			BuffWindow_UpdateWindow()
			BigBrother_BuffWindow:Show()
		end
	else
		CreateBuffWindow()
	end
end

function CreateBuffWindow()
	local BuffWindow
--[[
	if BigBrother_BuffWindow then
		BuffWindow_UpdateBuffs()
		BuffWindow_UpdateWindow()
		BigBrother_BuffWindow:Show()
		return
	end
]]
	BuffWindow=CreateFrame("FRAME",nil,UIParent)


	BuffWindow:ClearAllPoints()
	BuffWindow:SetPoint("CENTER",UIParent)

	BuffWindow:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
                                            edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
                                            tile = true, tileSize = 16, edgeSize = 16, 
                                            insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	BuffWindow:SetBackdropColor(0,0,0,0.5);

	BuffWindow:SetWidth(BarWidth+16+24);
	BuffWindow:SetHeight(190);

	BuffWindow:SetScript("OnMouseDown", function() 
						if ( ( ( not BigBrother_BuffWindow.isLocked ) or ( BigBrother_BuffWindow.isLocked == 0 ) ) and ( arg1 == "LeftButton" ) ) then
						  BigBrother_BuffWindow:StartMoving();
						  BigBrother_BuffWindow.isMoving = true;
						 end
						end)
	BuffWindow:SetScript("OnMouseUp", function() 
						if ( BigBrother_BuffWindow.isMoving ) then
						  BigBrother_BuffWindow:StopMovingOrSizing();
						  BigBrother_BuffWindow.isMoving = false;
						 end
						end)
					
	BuffWindow:SetScript("OnHide", function() 
						if ( BigBrother_BuffWindow.isMoving ) then
						  BigBrother_BuffWindow:StopMovingOrSizing();
						  BigBrother_BuffWindow.isMoving = false;
						 end
						end)
	

	BuffWindow:SetMovable(true)
	BuffWindow:EnableMouse()
	BuffWindow:Show()

	BuffWindow.Title=BuffWindow:CreateFontString(nil,"OVERLAY","GameFontNormal")
	BuffWindow.Title:SetPoint("TOP",BuffWindow,"TOP",0,-8)
	BuffWindow.Title:SetTextColor(1.0,1.0,1.0)

	BuffWindow.LeftButton=CreateFrame("Button",nil,BuffWindow)
	BuffWindow.LeftButton:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Up.blp")
	BuffWindow.LeftButton:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Down.blp")
	BuffWindow.LeftButton:SetWidth(16)
	BuffWindow.LeftButton:SetHeight(18)
	BuffWindow.LeftButton:SetPoint("TOPLEFT",BuffWindow,"TOPLEFT",64,-5)
	BuffWindow.LeftButton:SetScript("OnClick",function() 
							BigBrother_BuffWindow.SelectedBuffs=BigBrother_BuffWindow.SelectedBuffs-1
							if BigBrother_BuffWindow.SelectedBuffs==0 then
								BigBrother_BuffWindow.SelectedBuffs=table.getn(BigBrother_BuffTable)
							end
							BuffWindow_UpdateBuffs()
							BuffWindow_UpdateWindow()
						end)

	BuffWindow.RightButton=CreateFrame("Button",nil,BuffWindow)
	BuffWindow.RightButton:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up.blp")
	BuffWindow.RightButton:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down.blp")
	
	BuffWindow.RightButton:SetWidth(16)
	BuffWindow.RightButton:SetHeight(18)
	BuffWindow.RightButton:SetPoint("TOPRIGHT",BuffWindow,"TOPRIGHT",-64,-5)
	BuffWindow.RightButton:SetScript("OnClick",function() 
							BigBrother_BuffWindow.SelectedBuffs=BigBrother_BuffWindow.SelectedBuffs+1
							if BigBrother_BuffWindow.SelectedBuffs>table.getn(BigBrother_BuffTable) then
								BigBrother_BuffWindow.SelectedBuffs=1
								
							end
							BuffWindow_UpdateBuffs()
							BuffWindow_UpdateWindow()
						end)
	
	BuffWindow.CloseButton=CreateFrame("Button",nil,BuffWindow)
	BuffWindow.CloseButton:SetNormalTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Up.blp")
	BuffWindow.CloseButton:SetPushedTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Down.blp")
	BuffWindow.CloseButton:SetHighlightTexture("Interface\\Buttons\\UI-Panel-MinimizeButton-Highlight.blp")
	BuffWindow.CloseButton:SetWidth(20)
	BuffWindow.CloseButton:SetHeight(20)
	BuffWindow.CloseButton:SetPoint("TOPRIGHT",BuffWindow,"TOPRIGHT",-4,-4)
	BuffWindow.CloseButton:SetScript("OnClick",function() BigBrother_BuffWindow:Hide() end)


	BuffWindow.Rows={}
	for i=1,PlayersShown do
		BuffWindow.Rows[i]=BuffWindow_Functions:CreateBuffRow(BuffWindow,8,-4-i*(BuffSpacing+2))
	end

	RowsCreated=PlayersShown

	BuffWindow.ScrollBar=CreateFrame("SCROLLFRAME","BuffWindow_ScrollBar",BuffWindow,"FauxScrollFrameTemplate")
	BuffWindow.ScrollBar:SetScript("OnVerticalScroll", function() FauxScrollFrame_OnVerticalScroll(20, BuffWindow_UpdateWindow) end)

	BuffWindow.ScrollBar:SetPoint("TOPLEFT", BuffWindow.Rows[1], "TOPLEFT", 0, 0)
	BuffWindow.ScrollBar:SetPoint("BOTTOMRIGHT", BuffWindow.Rows[8], "BOTTOMRIGHT", 0, 0)




	-- drag handle
	
	BuffWindow.draghandle = CreateFrame("Frame", nil, BuffWindow)
	BuffWindow.draghandle:Show()
	BuffWindow.draghandle:SetFrameLevel( BuffWindow:GetFrameLevel() + 10 ) -- place this above everything
	BuffWindow.draghandle:SetWidth(BarWidth+16+24)
	BuffWindow.draghandle:SetHeight(16)
	BuffWindow.draghandle:SetPoint("BOTTOM", BuffWindow, "BOTTOM", 0, 0)
	BuffWindow.draghandle:EnableMouse(true)
	BuffWindow.draghandle:SetScript("OnMouseDown", function() this:GetParent().isResizing = true; this:GetParent():StartSizing("BOTTOMRIGHT") end )
	BuffWindow.draghandle:SetScript("OnMouseUp", function() this:GetParent():StopMovingOrSizing(); this:GetParent().isResizing = false; end )
	
	BuffWindow:SetMinResize(BarWidth+16+24,110)
	BuffWindow:SetMaxResize(BarWidth+16+24,530.5)	
	BuffWindow:SetResizable(true);

	BuffWindow:SetScript("OnSizeChanged", function()
						if ( BigBrother_BuffWindow.isResizing ) then
							BuffWindow_ResizeWindow()
						end
					end)
    

	BigBrother_BuffWindow=BuffWindow
	BigBrother_BuffWindow.SelectedBuffs=1
	BuffWindow_UpdateBuffs()
	BuffWindow_UpdateWindow()
end

--When called will update buffs and the window
function BuffWindow_Update()
	BuffWindow_UpdateBuffs()
	BuffWindow_UpdateWindow()
end



--When called will update the table of what buffs everyone has
function BuffWindow_UpdateBuffs()
	local unit
	local PlayerList={}
	local BuffChecking=BigBrother_BuffTable[BigBrother_BuffWindow.SelectedBuffs]
	local Filter=BuffChecking.filter

	for unit in RL:IterateRoster(false) do
		if BigBrother.db.profile.Groups[unit.subgroup] then
      if (not Filter) or Filter[unit.class] then
  			local player={}
  			player.name=unit.name
  			player.class=unit.class
  			player.totalBuffs=0
  			player.buff={}
				player.buffIndex={}
				player.unit=unit.unitid
  			for i, BuffList in pairs(BuffChecking.buffs) do
  				for _, buffs in pairs(BuffList) do
  					local index = aura:UnitHasBuff(unit.unitid, buffs[1])
						if index then
  						player.totalBuffs=player.totalBuffs+1
  						player.buff[i]=buffs
							player.buffIndex[i] = index
  						break
  					end
  				end
  			end
  			table.insert(PlayerList,player)
  		end
    end
	end

	table.sort(PlayerList,BuffChecking.sortFunc)
	BigBrother_BuffWindow.List=PlayerList
end

function BuffWindow_UpdateWindow()
	local PlayerList=BigBrother_BuffWindow.List
	local Rows=BigBrother_BuffWindow.Rows
	
	FauxScrollFrame_Update(BigBrother_BuffWindow.ScrollBar, table.getn(PlayerList), PlayersShown, 20)
	local offset = FauxScrollFrame_GetOffset(BigBrother_BuffWindow.ScrollBar)
	
	BigBrother_BuffWindow.Title:SetText(BigBrother_BuffTable[BigBrother_BuffWindow.SelectedBuffs].name)

	for i=1,PlayersShown do
		if PlayerList[i+offset] then
			local Player=PlayerList[i+offset]
			Rows[i]:SetPlayer(Player.name,Player.class,Player.unit)
			for j=1,5 do
				if Player.buff[j] then
					Rows[i]:SetBuffIcon(j,Player.buff[j][2])
					Rows[i]:SetBuffIndex(j,Player.buffIndex[j], Player.unit)
					Rows[i]:SetBuffValue(j,true)
				else
					Rows[i]:SetBuffValue(j,false)
				end
			end
			Rows[i]:Show()
		else
			Rows[i]:Hide()
		end
	end
end

function BuffWindow_ResizeWindow()

	local NumVisibleRows=math.floor( (BigBrother_BuffWindow:GetHeight() - (BuffSpacing+4)-8) / (BuffSpacing+2) )

	if NumVisibleRows>RowsCreated then
		for i=(1+RowsCreated),NumVisibleRows do
			BigBrother_BuffWindow.Rows[i]=BuffWindow_Functions:CreateBuffRow(BigBrother_BuffWindow,8,-4-i*(BuffSpacing+2))
			BigBrother_BuffWindow.Rows[i]:Hide()
		end
		RowsCreated=NumVisibleRows
	end

	if NumVisibleRows<PlayersShown then
		for i=(1+NumVisibleRows),PlayersShown do
			BigBrother_BuffWindow.Rows[i]:Hide()
		end
	end
	PlayersShown=NumVisibleRows

	BigBrother_BuffWindow.ScrollBar:SetPoint("BOTTOMRIGHT", BigBrother_BuffWindow.Rows[PlayersShown], "BOTTOMRIGHT", 0, 0)
	BuffWindow_UpdateWindow()
end

